﻿//using log4net;
//using Quartz;
//using RDIFramework.Utilities;
//using System;
//using System.Collections.Generic;
//using System.Configuration;
//using System.Data;
//using System.Globalization;
//using System.IO;
//using System.Linq;
//using System.Net;
//using System.Text;
//using System.Web.Script.Serialization;

//namespace TimedUpload.QuartzJobs
//{
//    /// <summary>
//    /// 2020-10-30 闽江源数据对接（新天集抄平台）
//    /// </summary>
//    [DisallowConcurrentExecution]
//    public class DataUploadMJYJob : IJob
//    {
//        private readonly ILog log = LogManager.GetLogger(typeof(IJob));

//        public void Execute(IJobExecutionContext context)
//        {
//            log.Info("抄表数据上传和达任务开始执行.................\r\n");
//            try
//            {
//                string now = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss", DateTimeFormatInfo.InvariantInfo);
//                string uploadTime = ConfigurationManager.AppSettings["uploadTime"];
//                string meterType = ConfigurationManager.AppSettings["meterType"];
//                string realS = ConfigurationManager.AppSettings["realS"];
//                #region 有现远传水表
//                String sql = "SELECT 表地址,表读数,ReviseDT FROM [Bsc_MeterInfo] where ReviseDT > '" + uploadTime + "'";
//                DataTable dt = dbHelper.Fill(sql);
//                int rowCount = dt.Rows.Count;

//                StringBuilder requestBody = new StringBuilder();
//                int sucessNum = 0;
//                for (int i = 0;i < rowCount; i++)
//                {
//                    string result = "";
//                    try
//                    {
//                        requestBody.Clear();
//                        long date = (Convert.ToDateTime(dt.Rows[i]["ReviseDT"]).ToUniversalTime().Ticks - 621355968000000000) / 10000000;
//                        requestBody.Append("{\"deviceId\":\"").Append(dt.Rows[i]["表地址"]).Append("\",");
//                        requestBody.Append("\"type\":\"").Append(meterType).Append("\",");
//                        requestBody.Append("\"real\":[{\"s\":\"").Append(realS).Append("\",");
//                        requestBody.Append("\"v\":").Append(Convert.ToDouble(dt.Rows[i]["表读数"])).Append(",");
//                        requestBody.Append("\"t\":").Append(date).Append("}]}");

//                        result = WebHelper.HttpWebRequest(Constants.uploadUrl, requestBody.ToString(), "POST", "application/json");
//                        sucessNum++;
//                    }
//                    catch (Exception)
//                    {
//                        log.Info("上传抄表数据：" + requestBody.ToString());
//                        log.Info("上传抄表数据接口返回结果：" + result);
//                    }
//                }

//                UpdateUploadTime(now);

//                log.Info("抄表数据共" + rowCount + "条数据,上传成功" + sucessNum + "条.................\r\n"); 
//                #endregion
//            }
//            catch (Exception ex)
//            {
//                log.Error("抄表数据上传任务异常:" + ex.Message);
//            }

//            log.InfoFormat("抄表数据上传任务执行结束.................\r\n");
//        }

//        /// <summary>
//        /// 更新配置文件中的更新数据时间
//        /// </summary>
//        /// <param name="time"></param>
//        private void UpdateUploadTime(string time)
//        {
//            var cfg = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
//            cfg.AppSettings.Settings["uploadTime"].Value = time;
//            cfg.Save();
//            ConfigurationManager.RefreshSection("appSettings");

//        }

//        static IDbProvider dbHelper
//        {
//            get
//            {
//                var DbDefine = DbFactoryProvider.GetProvider(CurrentDbType.SqlServer, Constants.DBUrl);
//                return DbDefine;
//            }
//        }
//    }
//}
